# Manage contract lifecycle transitions Source: https://docs.metronome.com/guides/customers-billing/manage-customers/manage-customer-lifecycle This use case walks through examples of how to use Metronome to manage contract lifecycle transitions. Contract lifecycle transitions happen when the relationship between a business and their customers changes. For example, after the initial signing of a deal, alterations like mid-term upsells, renewals, and the contract's expiration can occur. Metronome helps you manage the contract lifecycle, including the frictionless transitions between contract states. To support pricing and packaging flexibility for your organization, you can: * Create contracts that fully capture the agreed upon terms, pricing, and schedule * Update contracts to reflect new terms, upsells, downgrades, or new product launches * Conclude complex contracts and gate product usage * View a clear audit log of all contract lifecycle changes The examples on this page show how Metronome supports contract lifecycle management through the lens of different sales motions. ## Create an enterprise contract motion The terms of an enterprise contract can vary from one customer to another. Terms could include special access to non-public products, discounts on SKU-level list pricing, prepaid or postpaid commitments, and so on. Metronome supports an array of pricing and packaging motions, empowering your sales team to offer tailored deals without requiring IT or others to update the billing system. Metronome also powers your product entitlements workflow, ensuring that only a customer with an active contract can use your company's products and services. For example, your organization's sales team just offered a 1 year enterprise contract to a company named Moogle. The terms of the deal are a \$100,000 prepaid commitment for the right to use Product A starting on January 1st, 2025, with a discount of 10% off Product A's standard list price. To support this use case in Metronome: 1. Configure billable metrics to properly aggregate your customer’s usage. 2. Create products that represent the SKUs you’ll invoicing your customers for. 3. Set up a rate card to define your products’ standard pricing and entitlement. 4. Set up an integration with a downstream invoice provider like Stripe to support billing the customer. 5. Create a customer object representing Moogle. 6. Create a contract in Metronome associated with Moogle. You can create the contract with the [/contracts/create API](/api-reference/contracts/create-a-contract): ```bash theme={null} curl https://api.metronome.com/v1/contracts/create \ -H "Authorization: Bearer " \ -H "Content-Type: application/json" \ -d '{ "customer_id": "450f7264-9b3d-43d5-8ee1-fc369a144c01", "name": "Enterprise Contract", "uniqueness_key": "1234", "rate_card_id": "6f06fad5-d017-4674-8b7f-1e00a1208109", "starting_at": "2025-01-01T00:00:00Z", "ending_before": "2026-01-01T00:00:00Z", "commits": [ { "type": "prepaid", "name": "Prepaid Commit Moogle", "product_id": "7bb1bdf6-e4af-42e0-be27-3cde86056919", "access_schedule": { "credit_type_id": "2714e483-4ff1-48e4-9e25-ac732e8f24f2", "schedule_items": [ { "amount": 1000000, "starting_at": "2025-01-01T00:00:00Z", "ending_before": "2026-01-01T00:00:00Z" } ] }, "invoice_schedule": { "credit_type_id": "2714e483-4ff1-48e4-9e25-ac732e8f24f2", "schedule_items": [ { "amount": 1000000, "timestamp": "2025-01-01T00:00:00Z" } ] }, "rollover_fraction": 0.5, "priority": 100, "applicable_product_ids": ["d6695114-299b-4bd7-b57c-7a9134ba50ae"] } ], "overrides": [ { "starting_at": "2025-01-01T00:00:00Z", "ending_before": "2026-01-01T00:00:00Z", "entitled": true, "type": "multiplier", "multiplier": 0.9, "product_id": "d6695114-299b-4bd7-b57c-7a9134ba50ae" } ] }' ``` After creating the contract, power your entitlement workflows with the `/contracts/get` API. For example, use the `/contracts/get` API to confirm Moogle's contract is active before allowing them to use Product A. ## Mid-term add-ons and renewals motion Opportunities often arise to capture more value from an existing business relationship. This typically manifests in the form of mid-term add-ons to an active contract, including access to new SKUs, new monetary commitments with variable list price discounting, and early contract renewals. Metronome helps your sales team capitalize on opportunities as they arise, enables your product teams to roll out and charge for new features, and saves your IT team from the stress of managing frequent and complex contractual changes. ### Execute a mid-term add-on Your company plans to beta launch Product B on October 1st, 2025. You offer a 20% discounted rate to your customer named Moogle in exchange for a new \$10,000 prepaid commitment. This \$10,000 prepaid commitment would only apply to use of Product B, and would begin on October 1st, 2025. To support this use case in Metronome: 1. Create a usage-based product representing Product B. 2. Update the existing rate card to include Product B with your list pricing and default entitlement. Set Product B's entitlement to **false** by default. This ensures that only customers with access to Product B are charged for its usage. 3. Edit the existing Moogle contract to: * Change Product B's entitlement to **true**, scheduled for October 1st, 2025 * Add a new prepaid commit to the existing contract for \$10,000 scheduled for October 1st, 2025, configured so that only usage for Product B gets drawn down * Override the list rate for Product B to give a 20% discount to Moogle Edit the contract with the [/contracts/edit API](/api-reference/contracts/edit-a-contract): ```bash theme={null} curl https://api.metronome.com/v2/contracts/edit \ -H "Authorization: Bearer " \ -H "Content-Type: application/json" \ -d '{ "customer_id": "450f7264-9b3d-43d5-8ee1-fc369a144c01", "contract_id": "7b347536-56ac-4036-b5d1-67142b0d00e5", "add_commits": [ { "type": "prepaid", "name": "mid-term prepaid commit", "product_id": "7bb1bdf6-e4af-42e0-be27-3cde86056919", "access_schedule": { "credit_type_id": "2714e483-4ff1-48e4-9e25-ac732e8f24f2", "schedule_items": [ { "amount": 1000000, "starting_at": "2025-10-01T00:00:00Z", "ending_before": "2026-01-01T00:00:00Z" } ] }, "invoice_schedule": { "credit_type_id": "2714e483-4ff1-48e4-9e25-ac732e8f24f2", "schedule_items": [ { "amount": 1000000, "timestamp": "2025-10-01T00:00:00Z" } ] }, "rollover_fraction": 0.5, "priority": 100, "applicable_product_ids": ["f0608ff2-30b6-4010-b2a6-bada4296b8a0"] } ], "add_overrides": [ { "starting_at": "2025-10-01T00:00:00Z", "ending_before": "2026-01-01T00:00:00Z", "type": "multiplier", "multiplier": 0.8, "product_id": "f0608ff2-30b6-4010-b2a6-bada4296b8a0", "entitled": true } ] }' ``` ### Contract renewal Imagine it's now December 1st, 2025, meaning that Moogle has 1 month left on their existing contract. They're mostly satisfied with your services, and want to renew their contract to begin on January 1st, 2026 for another year. However, Moogle still has \$10,000 of prepaid commit remaining for Product A. Per the initial contract's details, the rollover percentage was set to 50% of the original balance in the event of a renewal. As \$10,000 is less than 50% of \$100,000, all \$10,000 of the remaining commit will roll over. Moogle likes this agreement, and renews with an additional \$200,000 prepaid commit for the combined usage of Product A and Product B. To support this use case in Metronome, create a new contract scheduled to begin on January 1st, 2026: 1. Assign the contract transition type **renewal** and link to the previous contract. 2. Add a prepaid commitment for \$200,000 configured to burn down as Product A and Product B get used. 3. Assume that one \$200,000 invoice gets sent on the contract start date (Jan 1st, 2026). On January 1st, 2026, the remaining \$10,000 in prepaid commit for Product A's usage rolls over to the new contract. This means that Moogle has two commits: one \$10,000 rollover commit solely for Product A's usage, and one \$200,000 prepaid commit for both Product A and Product B's usage. On this new contract, the \$10,000 rollover commit gets burned down first, before the \$200,000 commit is used. Complete the renewal with the `/contracts/create` API: ```bash theme={null} curl https://api.metronome.com/v1/contracts/create \ -H "Authorization: Bearer " \ -H "Content-Type: application/json" \ -d '{ "customer_id": "450f7264-9b3d-43d5-8ee1-fc369a144c01", "name": "Enterprise Contract Renewal", "uniqueness_key": "12345", "rate_card_id": "6f06fad5-d017-4674-8b7f-1e00a1208109", "starting_at": "2026-01-01T00:00:00Z", "ending_before": "2027-01-01T00:00:00Z", "commits": [ { "type": "prepaid", "name": "renewal prepaid commit", "product_id": "7bb1bdf6-e4af-42e0-be27-3cde86056919", "access_schedule": { "credit_type_id": "2714e483-4ff1-48e4-9e25-ac732e8f24f2", "schedule_items": [ { "amount": 20000000, "starting_at": "2026-01-01T00:00:00Z", "ending_before": "2027-01-01T00:00:00Z" } ] }, "invoice_schedule": { "credit_type_id": "2714e483-4ff1-48e4-9e25-ac732e8f24f2", "schedule_items": [ { "amount": 20000000, "timestamp": "2026-01-01T00:00:00Z" } ] }, "rollover_fraction": 0.5, "priority": 101, "applicable_product_ids": [ "d6695114-299b-4bd7-b57c-7a9134ba50ae", "f0608ff2-30b6-4010-b2a6-bada4296b8a0" ] } ], "transition": { "type": "renewal", "from_contract_id": "7b347536-56ac-4036-b5d1-67142b0d00e5" } }' ``` ## End a contract motion The end of a business relationship involves two critical tasks: ensuring the financial obligations stated in the contract are met, and that access to your company's products and services get quickly gated. Metronome supports both requirements, as the system automatically tracks the contract's terms in relation to your customer's usage and offers features to power your product entitlements workflow. This means that if a contract concludes before the expected end date, the client receives an invoice for their remaining financial obligations while simultaneously sending a signal to your product entitlements system that the customer is no longer active. For example, Moogle decides to part ways with your company before using their entire prepaid commitment, and wants to exit the renewed contract on March 1st, 2026. To support this use case in Metronome: 1. Schedule the end date of the existing contract to be effective on March 1st, 2026. 2. Ensure that you gate access to your product at the time of contract end: * Set up an [alert](/guides/customers-billing/set-up-notifications/create-and-manage-notifications) to generate a webhook upon a commit reaching a low balance (in this case, \$0.00) * Configure your entitlement system to listen for the webhook and immediately gate access As this customer was invoiced for the prepaid commit at the time of contract start (January 1st, 2026), they already received their \$200,000 bill from your invoice provider. On March 1st, 2026, the contract's remaining prepaid commit goes to \$0.00. Update the contract end date with the [/contracts/updateEndDate API](/api-reference/contracts/update-the-contract-end-date): ```bash theme={null} curl https://api.metronome.com/v1/contracts/updateEndDate \ -H "Authorization: Bearer " \ -H "Content-Type: application/json" \ -d '{ "customer_id": "450f7264-9b3d-43d5-8ee1-fc369a144c01", "contract_id": "7b347536-56ac-4036-b5d1-67142b0d00e5", "ending_before": "2026-03-01T00:00:00Z" }' ``` # Manage product access Source: https://docs.metronome.com/guides/customers-billing/manage-customers/manage-product-access Metronome goes beyond the traditional borders of the Q2C stack by directly enhancing the customer experience within your product. Metronome encodes contract terms that define customer access through various packaging models, tracks entitlement status in real-time based on usage and payment, and alerts you to any changes in these entitlements. ![Product access and entitlements](https://mintcdn.com/metronome-b35a6a36/WMVHzWf7d6M8Lnwb/images/manage-customers/manage-product-access.png?fit=max\&auto=format\&n=WMVHzWf7d6M8Lnwb\&q=85\&s=e3cba30e2dd6e19d4a8a490ff87df0f4) *** #### Provision a customer Learn how to provision a customer and assign a contract to them. This serves as the basis for encoding entitlements in Metronome. [Learn more >](/guides/get-started/core-concepts/provision-customer) *** #### Contract lifecycle transitions Manage the contract lifecycle to reflect the updated entitlements of a customer. This can be used to handle cases like renewals, upsells, and upgrade scenarios. [Learn more >](/guides/customers-billing/manage-customers/manage-customer-lifecycle) *** #### Create a trial Explore a common business model for providing temporary access to customers trying your product. This approach is typical in product-led growth (PLG) strategies, where you aim to streamline sign-ups while managing costs and encouraging customers to upgrade. [Learn more >](/guides/pricing-packaging/billing-model-guides/free-trials/overview) *** #### Create and manage notifications Explore this feature that supports a wide range of use cases in Metronome and enables communication about changes in entitlement states. [Learn more >](/guides/customers-billing/set-up-notifications/create-and-manage-notifications) # Manage unbillable invoices Source: https://docs.metronome.com/guides/customers-billing/manage-customers/manage-unbillable-invoices Prevent select invoices from being sent to a billing provider. Use `unbillable_invoices_configuration` to control contract invoices Metronome sends to a downstream billing provider. Invoices that are not sent are still finalized in Metronome, but they are marked `unbillable` during normal processing. Common use cases include: * Suppressing overage invoices for a prepaid customer. * Suppressing scheduled invoices (i.e. commit installments) billed directly in a cloud marketplace. `unbillable_invoices_configuration` is set on a customer billing provider configuration. To apply a policy to a contract, first create a billing provider configuration with the rules you want, then assign that configuration to the contract. If you omit `unbillable_invoices_configuration`, it defaults to `[]` and all invoices are billable. Existing integrations are unaffected. ## Define unbillable invoice rules `unbillable_invoices_configuration` is an array of rules. Each rule identifies invoices that Metronome treats as unbillable. | Field | Required | Description | | :- | :- | :- | | `invoice_type` | Yes | The invoice type the rule applies to: `USAGE` or `SCHEDULED`. | | `fiat_credit_type_id` | Conditional | The fiat currency the rule applies to. Required when `max_amount` is set. Omit to create a catch-all rule that applies to every fiat currency for the `invoice_type`. | | `max_amount` | No | A positive number in the units of `fiat_credit_type_id`. Invoices with a total less than or equal to this amount are unbillable. Omit to make every matching invoice unbillable regardless of amount. | An empty array, `[]`, is valid and means all invoices are billable. ## Supported billing providers | Billing provider | `USAGE` rules | `SCHEDULED` rules | | :- | :-: | :-: | | Stripe | ✅ | ✅ | | NetSuite | ✅ | ✅ | | Marketplace (AWS / Azure / GCP) | ❌ | ✅ | ### Rule precedence For a given invoice type, Metronome first looks for a rule that matches the invoice's `fiat_credit_type_id`. If one exists, Metronome evaluates only that rule. If no currency-specific rule exists, Metronome evaluates the catch-all rule for that invoice type, if one is present. ### Validation Metronome validates rules when you create the billing provider configuration and returns an error if any of the following are violated: * Every rule must include `invoice_type`, set to `USAGE` or `SCHEDULED`. * `max_amount`, when present, must be a positive number. * A rule with `max_amount` must include `fiat_credit_type_id`. * For the same `invoice_type`, each fiat credit type can appear in at most one rule. * For the same `invoice_type`, at most one catch-all rule can omit `fiat_credit_type_id`. * Marketplace configurations only support `SCHEDULED` rules. ## Apply rules to a new contract ### Suppress all overage invoices Let's walk through an example for suppressing all overage invoices for a prepaid customer: **Step 1: Create the billing provider configuration** ```bash theme={null} curl https://api.metronome.com/v1/setCustomerBillingProviderConfigurations \ -H "Authorization: Bearer " \ -H "Content-Type: application/json" \ -d '{ "data": [ { "customer_id": "8cecbf69-960f-4f66-9575-edebb7d95e88", "billing_provider": "stripe", "delivery_method": "direct_to_billing_provider", "configuration": { "stripe_customer_id": "cus_123", "stripe_collection_method": "charge_automatically" }, "unbillable_invoices_configuration": [ { "invoice_type": "USAGE" } ] } ] }' ``` **Step 2: Create a contract with the configuration** ```bash theme={null} curl https://api.metronome.com/v1/contracts/create \ -H "Authorization: Bearer " \ -H "Content-Type: application/json" \ -d '{ "customer_id": "8cecbf69-960f-4f66-9575-edebb7d95e88", "starting_at": "2026-09-01T00:00:00.000Z", "rate_card_id": "d7abd0cd-4ae9-4db7-8676-e986a4ebd8dc", "billing_provider_configuration": { "billing_provider_configuration_id": "a1b2c3d4-e5f6-7890-abcd-ef1234567890" } }' ``` All usage invoices on the new contract have a `billable_status` of `unbillable`. ### Send overages over a fixed amount Make USD usage invoices with totals up to 10 unbillable. USD usage invoices above 10 and all scheduled invoices remain billable. ```bash theme={null} curl https://api.metronome.com/v1/setCustomerBillingProviderConfigurations \ -H "Authorization: Bearer " \ -H "Content-Type: application/json" \ -d '{ "data": [ { "customer_id": "8cecbf69-960f-4f66-9575-edebb7d95e88", "billing_provider": "stripe", "delivery_method": "direct_to_billing_provider", "configuration": { "stripe_customer_id": "cus_456", "stripe_collection_method": "charge_automatically" }, "unbillable_invoices_configuration": [ { "invoice_type": "USAGE", "fiat_credit_type_id": "2714e483-4ff1-48e4-9e25-ac732e8f24f2", "max_amount": 1000 } ] } ] }' ``` ### Example: Suppress scheduled invoices billed to a cloud marketplace ```bash theme={null} curl https://api.metronome.com/v1/setCustomerBillingProviderConfigurations \ -H "Authorization: Bearer " \ -H "Content-Type: application/json" \ -d '{ "data": [ { "customer_id": "8cecbf69-960f-4f66-9575-edebb7d95e88", "billing_provider": "aws_marketplace", "delivery_method": "direct_to_billing_provider", "configuration": { "aws_customer_id": "cust_789", "aws_product_code": "my_product", "aws_region": "us-west-1" }, "unbillable_invoices_configuration": [ { "invoice_type": "SCHEDULED" } ] } ] }' ``` ## Apply rules to an existing contract To change the policy on an existing contract, create a new billing provider configuration with the appropriate billable settings. Then, schedule a change to the customer billing provider configuration on the contract, replacing the existing configuration with the new one created. ## Constraints and considerations > [!NOTE] > > **Draft invoice totals can switch from unbillable to billable.** For rules with `max_amount`, Metronome evaluates the invoice's current total, so a draft invoice's `billable_status` can change as its total changes. Once an invoice is finalized, its total and `billable_status` are stable. > [!NOTE] > > **You can manually send an unbillable Stripe invoice.** In the Metronome app, an authorized user can click **Send to Stripe** to send an individual unbillable invoice. After the invoice is sent, its `billable_status` is `billable`. This is only available for Stripe. > [!NOTE] > > **Voided and regenerated invoices use the original period's configuration.** When Metronome voids and regenerates an invoice, the regenerated invoice uses the billing provider configuration from the invoice's service period. # Provision a customer Source: https://docs.metronome.com/guides/customers-billing/manage-customers/provision-a-customer In Metronome, customers are the recipients of an invoice and may represent individual users, enterprises, API keys, or whatever specification your organization needs. This guide describes how to provision a customer in Metronome. Provisioning your customer includes creating the customer object and configuring the associated contract that outlines their terms of use. A customer needs at least one contract provisioned to them to start metering and rating for billing. You can also configure multiple contracts per customer, if needed. ## Prerequisites Before provisioning a customer you must have: * Your [usage events](/guides/events/design-usage-events) connected to Metronome * A [billable metric](/guides/get-started/core-concepts/create-billable-metrics/) * A [product](/guides/get-started/core-concepts/create-products-contracts) * A [rate card](/guides/get-started/core-concepts/create-manage-rate-cards) ## Create a customer Create an individual customer object in Metronome or build a flow to create customers programmatically from system triggers. ### Understand ingest aliases Ingest aliases map your internal customer identifiers to Metronome's customer ID. When you send usage keyed on an ingest alias, Metronome automatically associates it to the correct Metronome customer. This allows you to maintain your existing customer entities without needing to swap in a Metronome customer ID. Ingest aliases can also be used to maintain account hierarchy. Enterprise customers often have sub-organizations that roll up to a single contract. Use ingest aliases to model this. For example, you can represent the enterprise organization as a customer in Metronome, with each sub-organization represented by an ingest alias attached to that customer: ``` Parent Account - Metronome Customer e7f893e5-07f7-483b-8c16-6905944c6a89 + Sub-Org 1 - IngestAlias1 + Sub-Org 2 - IngestAlias2 + Sub-Org 3 - IngestAlias3 + Sub-Org 4 - IngestAlias4 ``` You can split out each sub-organization's usage on the invoice Metronome generates. Learn how to use [group keys](/guides/get-started/core-concepts/create-billable-metrics#3-define-group-keys%E2%80%8B) to modify invoice presentation. Ingest aliases can be specified on the Metronome customer object at time of creation or any point after. Retroactively adding an ingest alias on the customer is a way to take Metronome out of the hot path of customer signup while properly metering usage. For example, if you first send usage keyed on `IngestAlias1` and later add this ingest alias to an existing customer, Metronome retroactively associates that usage to the correct customer. ### Create a customer with the Metronome app To create a customer using the app: 1. Go to the **Customers** page → **Add a customer**. 2. Add a name. 3. Add an ingest alias. 4. (Optional) Set a custom field for the customer on the **Settings** tab. ### Build a customer creation flow with the API Use the Metronome API to build a flow for creating customers in Metronome programmatically based on sales-led or product-led motions. For a sales-led motion, you might use Salesforce CPQ to capture opportunities. When an opportunity closes, you can schedule a job to create a customer using the Metronome API. This example request shows how to: * Create a mock customer, WidgetsExpress, in Metronome * Codify the relationship between the Metronome customer and the SFDC account by storing the `sfdc_account_id` in a custom field ```bash theme={null} curl https://api.metronome.com/v1/customers \ -H "Authorization: Bearer " \ -H "Content-Type: application/json" \ -d '{ "ingest_aliases": [ "team@widgetsexpress.com" ], "name": "WidgetsExpress", "custom_fields": { "sfdc_account_id": "sfdc1001" } }' ``` For a product-led growth motion, create a similar workflow where the trigger originates from a signup on your website. Store the relationship between the Metronome customer and your internal customer object. ### Add a billing configuration to a customer A customer in Metronome can billed in different destinations, often depending on your billing motion. You must first create a `customer_billing_provider_configuration` on the customer and then assign it to a contract. Metronome allows you to configure multiple `customer_billing_provider_configurations` per customer, which means one customer can be billed in multiple systems - one per contract. > [!NOTE] > > **INFO** > > Before setting up a `customer_billing_provider_configuration`, Metronome must first be connected to the relevant system. Follow the steps in [Invoice with Stripe](/integrations/invoice-integrations/stripe) or [Invoice with the Marketplaces (AWS and Azure)](/integrations/marketplace-integrations/aws). Metronome recommends setting the `customer_billing_provider_configurations` on customer creation. For example, let's say WidgetsExpress purchased your product via AWS Marketplace. Amend the previous call to add a `customer_billing_provider_configurations` to the WidgetExpress customer: ```bash theme={null} curl https://api.metronome.com/v1/customers \ -H "Authorization: Bearer " \ -H "Content-Type: application/json" \ -d '{ "ingest_aliases": [ "team@widgetsexpress.com" ], "name": "WidgetsExpress", "custom_fields": { "sfdc_account_id": "sfdc1001" }, "customer_billing_provider_configurations": [ { "billing_provider": "aws_marketplace", "configuration": { "aws_customer_id": "ABC123ABC12", "aws_product_code": "my_product", "aws_region": "us-west-1" }, "delivery_method": "direct_to_billing_provider" } ] }' ``` After submission, the customer will be created with the associated AWS configuration. However, it will not be billed to AWS until a contract is created with AWS set as the contract's `billing_provider_configuration`. If you do not set a `customer_billing_provider_configuration` on customer creation, you can add one later using the `/setCustomerBillingProviderConfigurations` endpoint. > [!NOTE] > > **BETA** > > You can archive a `customer_billing_provider_configuration` by either archiving the customer or archiving the specific configuration via the `/archiveCustomerBillingProviderConfigurations` endpoint. When you archive a billing configuration, it becomes available for reuse on a new customer. If you archive a `customer_billing_provider_configuration` that is attached to an active contract, the config will be archived on the contract immediately and no longer bill to the associated destination. A new `billing_provider_configuration` cannot be provisioned on the contract. ## Provision a customer contract Define a contract in Metronome that encodes the products customers can access, rates for each product, and access duration. Just as rate cards are built on products, contracts are built on rate cards. A contract references a specific rate card and bundles it with other Metronome models like [commits,](/guides/pricing-packaging/apply-credits-and-commits/create-a-pre-paid-commit) discounts, fixed products that don't live on the rate card, and more. Create contracts with the Metronome app or with the [/contracts/create endpoint](/api-reference/contracts/create-a-contract). ### Create a contract Consider an example where your customer, WidgetsExpress, purchased a prepaid commit for \$10,000 that applies to your cloud products via AWS Marketplace. This commit lasts for a year. As part of the contract, they also pay a \$1,000 platform fee each quarter to use your service. They pay for the prepaid commit once upfront and for usage on a monthly basis. To provision this contract with the [Metronome app](https://app.metronome.com/): 1. Navigate to *Customers* and select your newly created customer. 2. On the *Overview* tab, click the **+ Add** button on the right hand side of the *Contracts* pane. 3. Fill in the *Basic* info for the contract like the contract name, start date, and rate card to use. Be sure to set the billing provider to AWS. 4. Under *Terms*, click **Add -> Commit** and fill in the details for the prepaid commit. 5. Under *Terms*, click **Add -> Scheduled charges** and add the platform fee as a scheduled charge. The final contract looks like: ![Final contract](https://mintcdn.com/metronome-b35a6a36/C_lGxKgdkdHt6xoX/images/manage-customers/provision-contract-fe412f3eebd53427e5c051a091504620.png?fit=max\&auto=format\&n=C_lGxKgdkdHt6xoX\&q=85\&s=f65fd32892d905d20bf0223a1c8b6350) To create the example contract with the `/contracts/create` API, execute this call: ```bash theme={null} curl https://api.metronome.com/v1/contracts/create \ -H "Authorization: Bearer " \ -H "Content-Type: application/json" \ -d '{ "customer_id": "aa58107d-162f-407e-9f09-940f16adbb1c", "rate_card_alias": "base_usage_products", "starting_at": "2024-11-01T00:00:00.000Z", "billing_provider_configuration": { "billing_provider": "aws_marketplace", "delivery_method": "direct_to_billing_provider" }, "commits": [ { "type": "prepaid", "name": "Contract Prepaid Commit", "product_id": "a1f4e40b-f8c4-496b-b687-0a103396b479", "access_schedule": { "schedule_items": [ { "amount": 1000000, "starting_at": "2024-11-01T00:00:00.000Z", "ending_before": "2025-11-01T00:00:00.000Z" } ] }, "invoice_schedule": { "schedule_items": [ { "unit_price": 1000000, "quantity": 1, "timestamp": "2024-11-01T00:00:00.000Z" } ] }, "applicable_product_tags": ["cloud"], "description": "Usage Commit" } ], "scheduled_charges": [ { "product_id": "06cf3703-3f5e-467c-8ba1-0ee934c740b9", "name": "Platform Charge", "schedule": { "recurring_schedule": { "starting_at": "2024-11-01T00:00:00.000Z", "ending_before": "2025-11-01T00:00:00.000Z", "frequency": "quarterly", "unit_price": 100000, "quantity": 1, "amount_distribution": "each" } } } ], "usage_statement_schedule": { "frequency": "monthly", "day": "contract_start" } }' ``` ## Consolidate usage and scheduled invoices You have the option to specify if scheduled invoices should consolidate onto a customer's usage invoices. This setting applies to all charges (including commits) on the contract. It follows this logic to determine whether to consolidate invoices: * The last day of the usage service period (exclusive) falls on the same day as the scheduled date for the scheduled invoice. * The corresponding usage invoice hasn't finalized. Consolidation occurs at the time of contract creation and upon any contract changes in the future. Consider an example where a new customer buys the Best package on your website, which costs \$75 per month. As part of this package, they receive a \$100 monthly commit. The contract and recurring commit start on January 1 with no end date. If `scheduled_charges_on_usage_invoices` is set to `ALL`, the contract creates these invoices: * **Invoice 1:** Issued and finalized on January 1 with one line item for the \$75 monthly charge. * **Invoice 2:** Created in draft with one line item for the \$75 monthly charge in February in addition to all usage charges for January. * **Invoice X:** Assuming no changes to the contract, all future invoices will model invoice 2. ## Add contract discounts and overrides Provide discounts during contract creation or by editing an existing contract. Apply discounts with credits, [overrides for product rates](/guides/pricing-packaging/make-pricing-changes/edit-or-override-a-contract), price tiers, and more. If you use dimensional pricing, set price overrides for each combination of group key and product. To add additional terms like credits, commits, overrides for product rates, and more, edit the contract. Consider the example with your mock customer WidgetsExpress to see this in practice. The customer negotiated a discount on cloud products. To address this, edit the contract by overriding products with the `cloud` tag to be 5% off of the basic rate card. To edit a contract with the Metronome app, go to the WidgetsExpress customer → Contracts -> and select the contract that you would like to edit. To edit a contract through the API, execute this call: ```bash theme={null} curl https://api.metronome.com/v2/contracts/edit \ -H "Authorization: Bearer " \ -H "Content-Type: application/json" \ -d '{ "customer_id": "aa58107d-162f-407e-9f09-940f16adbb1c", "contract_id": "0a6180da-336a-40e6-98f4-20b6be08211d", "add_overrides": [ { "starting_at": "2024-11-01T00:00:00.000Z", "entitled": true, "type": "multiplier", "multiplier": 0.95, "applicable_product_tags": ["cloud"] } ] }' ``` ## Create a usage filter You can provision a customer with multiple contracts simultaneously. These contracts can use distinct rate cards, have different start and end dates, discounts, and more. They can all draw down from shared customer-level commits and credits. To specify that usage should count against one contract instead of another, create a usage filter for that contract. For example, your mock customer WidgetsExpress has three sub-divisions: US, EU, and APAC. Each division negotiated different discounts. To model this in Metronome, create a contract for each sub-division and use usage filters to ensure only the appropriate usage gets routed to each contract. When creating the US contract, ensure that only events with the property `region` and value ` US` are included in this contract using this API call: ```bash theme={null} curl https://api.metronome.com/v1/contracts/create \ -H "Authorization: Bearer " \ -H "Content-Type: application/json" \ -d '{ "customer_id": "13117714-3f05-48e5-a6e9-a66093f13b4d", "rate_card_id": "d7abd0cd-4ae9-4db7-8676-e986a4ebd8dc", "starting_at": "2024-10-01T00:00:00.000Z", "usage_filter": { "group_key": "region", "group_values": [ "US" ] } }' ``` You can update the usage filter on a contract at any time, on a schedule. For example, imagine that as of 2025, WidgetsExpress no longer wants usage within their EU division invoiced separately. Instead, they should get billed through the US contract, using US prices. This API call shows how to update the usage filter, with the edit taking effect on Jan 01, 2025: ```bash theme={null} curl https://api.metronome.com/v1/contracts/setUsageFilter \ -H "Authorization: Bearer " \ -H "Content-Type: application/json" \ -d '{ "customer_id": "13117714-3f05-48e5-a6e9-a66093f13b4d", "contract_id": "d7abd0cd-4ae9-4db7-8676-e986a4ebd8dc", "group_key": "region", "group_values": ["US", "EU"], "starting_at": "2025-01-01T00:00:00.000Z" }' ``` Usage filters have these limitations: * For [streaming billable metrics](/guides/get-started/core-concepts/create-billable-metrics/), you must define the usage filter as a group key on the underlying billable metric. If you're also using dimensional pricing and presentation group keys, the usage filter group key must be defined in a compound group key on the underlying billable metric with the dimensional pricing and presentation group keys. * For [SQL billable metrics](/guides/get-started/core-concepts/create-billable-metrics#define-group-keys-on-sql-billable-metrics%E2%80%8B/), the group key for the usage filter must be present as property value in the underlying events (for example, `properties.region`). * `LATEST` billable metrics are not currently compatible with contract-level usage filters. Applying a contract-level usage filter to a contract that rates a product backed by a `LATEST` billable metric can cause invoice computation errors. Use `LATEST` only on contracts without usage filters. ## Add custom fields Use [custom fields](/developer-resources/custom-fields/) to add additional metadata to the contract or commit. This metadata can power downstream processes like revenue recognition workflows. For example, if you're integrating with SFDC, you can create a custom field for `salesforce_opportunity_id` to map Metronome contracts, and revenue derived from it, to the associated SFDC opportunity. # Schedule a billing provider change Source: https://docs.metronome.com/guides/customers-billing/manage-customers/schedule-billing-provider-change Switch billing providers on an existing contract without creating a new one. Schedule the addition, removal, correction, or switching of a billing provider on a contract. A contract stores a **billing provider configuration schedule** — an ordered list of segments each with an `effective_at` timestamp aligned to a billing period boundary or, for `TODAY`, to the start of the current day in UTC (or the contract start, if that's later). The active configuration for a given invoice is the segment with the latest `effective_at` date before the service period end date or `issued~at` date if there is no service period end date. ## Supported transitions | From → To | Current period | Next period | Today | | :- | :-: | :-: | :-: | | null → Stripe | ✅ | ✅ | ✅ | | Stripe → Stripe | ✅ | ✅ | ✅ | | Stripe → NetSuite | ✅ | ✅ | ❌ | | Stripe → null | ✅ | ✅ | ✅ | | NetSuite → Stripe | ✅ | ✅ | ❌ | | NetSuite → null | ✅ | ✅ | ❌ | | Stripe → Marketplace (AWS / Azure / GCP) | ❌ | ✅ | ❌ | | Marketplace → Stripe | ❌ | ✅ | ❌ | | Marketplace → Marketplace | ❌ | ✅ | ❌ | | NetSuite → Marketplace | ❌ | ✅ | ❌ | | Marketplace → NetSuite | ❌ | ✅ | ❌ | | Marketplace → null | ❌ | ✅ | ❌ | ## Schedule a change Use the `add_billing_provider_configuration_update` field on `POST v2/contracts/edit`. The `effective_at` controls when the new configuration takes effect: `START_OF_CURRENT_PERIOD`, `START_OF_NEXT_PERIOD`, or `TODAY`. **Example: Correct a Stripe misconfiguration, effective immediately** Switch from one Stripe configuration to another at the start of the current period. The current draft invoice will be routed to the new configuration. If an invoice was already finalized and sent to Stripe during this period, the new configuration will not apply to it — all invoices are guaranteed to be sent exactly once. ```bash theme={null} curl https://api.metronome.com/v2/contracts/edit \ -H "Authorization: Bearer " \ -H "Content-Type: application/json" \ -d '{ "customer_id": "8cecbf69-960f-4f66-9575-edebb7d95e88", "contract_id": "6058587f-763c-400f-a822-3edb3eb2b86b", "add_billing_provider_configuration_update": { "billing_provider_configuration": { "billing_provider_configuration_id": "a1b2c3d4-e5f6-7890-abcd-ef1234567890", }, "schedule": { "effective_at": "START_OF_CURRENT_PERIOD" } } }' ``` **Example: Switch to a different Stripe configuration, effective today** `TODAY` takes effect at the start of the current day in UTC, or at the contract start if that's later. An invoice with a service period uses the new configuration if its service period ends after that time. An invoice without a service period uses it if it is issued at or after that time. So the current period's usage invoice moves to the new configuration, and an invoice without a service period that was issued before that time keeps its existing configuration. ```bash theme={null} curl https://api.metronome.com/v2/contracts/edit \ -H "Authorization: Bearer " \ -H "Content-Type: application/json" \ -d '{ "customer_id": "8cecbf69-960f-4f66-9575-edebb7d95e88", "contract_id": "6058587f-763c-400f-a822-3edb3eb2b86b", "add_billing_provider_configuration_update": { "billing_provider_configuration": { "billing_provider_configuration_id": "a1b2c3d4-e5f6-7890-abcd-ef1234567890" }, "schedule": { "effective_at": "TODAY" } } }' ``` **Example: Transition from Stripe to AWS Marketplace, effective next period** All invoices from the current billing period are routed based on the existing Stripe configuration. The marketplace configuration takes effect at the start of the next period. ```bash theme={null} curl https://api.metronome.com/v2/contracts/edit \ -H "Authorization: Bearer " \ -H "Content-Type: application/json" \ -d '{ "customer_id": "8cecbf69-960f-4f66-9575-edebb7d95e88", "contract_id": "6058587f-763c-400f-a822-3edb3eb2b86b", "add_billing_provider_configuration_update": { "billing_provider_configuration": { "billing_provider_configuration_id": "b2c3d4e5-f6a7-8901-bcde-f12345678901" }, "schedule": { "effective_at": "START_OF_NEXT_PERIOD" } }' ``` **Example: Transition from Stripe to no billing provider, effective current period** All invoices from the current billing period *will not* be routed to any downstream destination. ```bash theme={null} curl https://api.metronome.com/v2/contracts/edit \ -H "Authorization: Bearer " \ -H "Content-Type: application/json" \ -d '{ "customer_id": "8cecbf69-960f-4f66-9575-edebb7d95e88", "contract_id": "6058587f-763c-400f-a822-3edb3eb2b86b", "add_billing_provider_configuration_update": { "billing_provider_configuration": { "billing_provider_configuration_id": null } "schedule": { "effective_at": "START_OF_CURRENT_PERIOD" } }' ``` ## View the billing provider configuration schedule Fetch a contract using `POST v2/contracts/get` to view the full schedule. The `customer_billing_provider_configuration` field returns the currently-active configuration unchanged. The `billing_provider_configuration_schedule` field returns an ordered list of all past, current, and future segments. ```json theme={null} { "data": { "id": "6058587f-763c-400f-a822-3edb3eb2b86b", "customer_id": "8cecbf69-960f-4f66-9575-edebb7d95e88", "customer_billing_provider_configuration": { "id": "a1b2c3d4-e5f6-7890-abcd-ef1234567890", "billing_provider": "stripe", "delivery_method": "direct_to_billing_provider" }, "billing_provider_configuration_schedule": [ { "billing_provider_configuration": { "id": "a1b2c3d4-e5f6-7890-abcd-ef1234567890", "billing_provider": "stripe", "delivery_method": "direct_to_billing_provider" }, "effective_at": "2025-01-01T00:00:00.000Z", "effective_until": "2025-06-01T00:00:00.000Z" }, { "billing_provider_configuration": { "id": "b2c3d4e5-f6a7-8901-bcde-f12345678901", "billing_provider": "aws_marketplace", "delivery_method": "direct_to_billing_provider" }, "effective_at": "2025-06-01T00:00:00.000Z", "effective_until": null } ] } } ``` ## Constraints and considerations > [!NOTE] > > **Changes align to billing period boundaries.** `START_OF_CURRENT_PERIOD` resolves to the start of the current usage invoice service period. `START_OF_NEXT_PERIOD` resolves to the start of the following service period. `TODAY` is the exception: it resolves to the start of the current day in UTC, or the contract start if that's later, and is only supported when the current and new billing providers are each Stripe or null. Each invoice maps to exactly one billing provider configuration, based on the end of its service period (exclusive), or on its issue date when it has no service period. > [!NOTE] > > **Marketplace transitions require `START_OF_NEXT_PERIOD`.** Marketplace billing is metered from the start of a period, so mid-period transitions are not supported. When transitioning to a marketplace, the current period completes fully on the existing configuration. When transitioning away, the marketplace continues to bill through the end of the current period. > [!NOTE] > > **Threshold billing must be disabled before switching to a marketplace provider.** If a contract has an active threshold billing configuration, it must be removed before scheduling a transition to any marketplace provider. > [!NOTE] > > **`customer_billing_provider_configuration` is unchanged and backward compatible.** The existing field on `contracts/get` and `contracts/list` responses continues to return the currently-active configuration. No changes are required to existing integrations that read this field. > [!NOTE] > > **A maximum of 10 schedule segments per contract.** If you need additional capacity on a specific contract, contact your account team. > [!NOTE] > > **To cancel a scheduled future change**, schedule a new segment covering the same period. The latest segment takes precedence. # Spend trackers Source: https://docs.metronome.com/guides/customers-billing/manage-customers/spend-trackers > [!NOTE] > > **Public Beta** > > Spend trackers are currently in a Public Beta. Breaking changes may occur between now and GA. Please use the [Metronome support portal](https://app.metronome.com/support) to request access. For certain billing models, it might be useful to track the spend of a customer over-time. These trackers might be used to inform discounting schemes or provide visibility to the end-customer. Create a `spend_tracker` on the contract to track the total spend for specific charges over time. ## Create a spend tracker Spend trackers return the summation of specified charges over a period of time - `spend_tracker.reset_frequency`. Spend trackers can be set on Package creation, contract creation, or contract edit. Other configurations on the contract can point at the spend tracker to manage spend based thresholds. For example, we can create a spend tracker to cap the amount of discounted prepaid commit purchases a customer can get in a single month. `applicable_spend_specifiers` specify which charges should count against the spend tracker: * *`spend_type`:* Today, only commit purchases can count towards a spend tracker. * *`sources`:* Specify whether commits created manually and / or threshold billing commits count towards the spend tracker. * *`discounted`:* Optionally specify whether commits marked as "discounted" count towards the spend tracker. For manual commits, this is defined via `spend_tracker_attributes.count_as_discounted`. For threshold billing commits, it is defined via the `discount_config`. See the example contract below: ```bash theme={null} curl https://api.metronome.com/v1/contracts/create \ -H "Authorization: Bearer " \ -H "Content-Type: application/json" \ -d '{ "customer_id": "8cecbf69-960f-4f66-9575-edebb7d95e88", "rate_card_id": "a7bc3775-b651-46b6-b7e4-d225a7e55c4c", "starting_at": "2025-04-01T00:00:00.000Z", ... "spend_trackers": [ { "alias": "promo-cap", "credit_type_id": "usd_credit_type_id", "reset_frequency": "BILLING_PERIOD", "applicable_spend_specifiers": [ { "spend_type": "COMMIT_PURCHASE", "sources": ["THRESHOLD_RECHARGE", "MANUAL"], "discounted": "DISCOUNTED_ONLY" } ] } ], "prepaid_balance_threshold_configuration": { "commit": { "product_id": "d6be3bf4-1669-40c9-a8b1-388bb167ab16", "name": "prepaid-balance", "description": "threshold billing recharges" }, "discount_config": { "fraction": 0.90, "cap": { "spend_tracker_alias": "promo-cap", "amount": 20000 } }, "is_enabled": true, "payment_gate_config": { "payment_gate_type": "STRIPE", "stripe_config": { "payment_type": "INVOICE" } }, "threshold_amount": 500, "recharge_to_amount": 2000 } }' ``` For this contract, we have a spend tracker that is scoped to include discounted manual and threshold billing commits. The `discount_config` on the `prepaid_balance_threshold_configuration` points at this spend tracker to enforce a cap. When the cap is reached, new threshold commits will not be discounted until the start of the next billing period. ## Get spend tracker total Once set up, you can query the contract to return the current spend counted towards the tracker within the current period. See an example below: ```bash theme={null} curl https://api.metronome.com/v2/contracts/get \ -H "Authorization: Bearer " \ -H "Content-Type: application/json" \ -d '{ "data": { "id": "d7abd0cd-4ae9-4db7-8676-e986a4ebd8dc", "customer_id": "13117714-3f05-48e5-a6e9-a66093f13b4d", ... "spend_trackers": [ { "alias": "promo-cap", "credit_type_id": "usd_credit_type_id", "reset_frequency": "BILLING_PERIOD", "accumulated_spend": { "amount": 14253.22, "period_starting_at": "2026-05-01T00:00:00.000Z", "period_ending_before": "2026-06-01T00:00:00.000Z" }, "applicable_spend_specifiers": [ { "spend_type": "COMMIT_PURCHASE", "sources": ["THRESHOLD_RECHARGE", "MANUAL"], "discounted": "DISCOUNTED_ONLY" } ] } ] } }' ``` While spend trackers can be used to dynamically trigger certain configurations, like the threshold billing discount config shown above, users can leverage this spend tracker to enforce internal pricing schemes. For example, if you wanted to enforce a spend cap for [payment gated commits](/guides/pricing-packaging/apply-credits-and-commits/manual-payment-gated-commits), you could check the spend tracker before issuing the commit to enforce a cap. # Let customers manage spend and usage Source: https://docs.metronome.com/guides/customers-billing/optimize-customer-experience/customer-controls Transparency is crucial in usage-based pricing. Enabling customers to monitor and manage their usage in real time builds trust and encourages product adoption. Metronome provides the data and real-time control necessary to implement flexible and customizable billing functionality directly in your product. Using threshold notifications, you can give your customers the power to proactively manage spend limits, commit balances, and invoice totals. Metronome evaluates threshold notifications as usage events are processed, triggering alarm states when a threshold is reached. The notifications are sent to your application through a preconfigured webhook, allowing you to take action as soon as the alarm state triggers as part of your entitlement management workflows. To learn more about supported notification types and behavior, see [Create and manage notifications](/guides/customers-billing/set-up-notifications/create-and-manage-notifications). ## Enable custom spend limits​ Spend limits provide an important safety mechanism to reassure customers that their total costs won't exceed a predefined threshold. These limits trigger notifications and prevent further service usage in the case of a hard limit. Implement spend limits with the following workflow: 1. An end user sets limits in your application (see example UI below) 2. Using the Metronome API, your application creates a `spend_threshold_reached` notification for each limit with a threshold matching the values entered by the end user 3. Metronome continuously evaluates the spend for the billing period, setting the notification to an `in_alarm` state once the threshold is reached 4. Metronome sends a notification to a webhook configured for your application that you can use to notify your customer and optionally block access to the service ![Set spend limits](https://mintcdn.com/metronome-b35a6a36/WMVHzWf7d6M8Lnwb/images/optimize-customer-experience/set-spend-limits-71e4ad74fa36b7482519de795e47af49.png?fit=max\&auto=format\&n=WMVHzWf7d6M8Lnwb\&q=85\&s=2e1a047da0bf0354680abb77d67176dd) The following API calls show how to set notifications in Metronome based on a spend threshold, enabling you to support your end users’ ability to set soft and hard limits. Each response returns the ID of the created threshold notification. Save these to a table to make them easily available when a user wants to update their soft and hard spend limits. ```bash theme={null} curl https://api.metronome.com/v1/alerts/create \ -H "Authorization: Bearer " \ -H "Content-Type: application/json" \ -d '{ "alert_type": "spend_threshold_reached", "credit_type_id": "2714e483-4ff1-48e4-9e25-ac732e8f24f2", "name": "SOFT spend threshold", "threshold": 5000, "customer_id": "75077603-26d4-45c0-a4b7-97b082ccc5f9" }' curl https://api.metronome.com/v1/alerts/create \ -H "Authorization: Bearer " \ -H "Content-Type: application/json" \ -d '{ "alert_type": "spend_threshold_reached", "credit_type_id": "2714e483-4ff1-48e4-9e25-ac732e8f24f2", "name": "HARD spend threshold", "threshold": 10000, "customer_id": "75077603-26d4-45c0-a4b7-97b082ccc5f9" }' ``` > [!NOTE] > > **INFO** > > The `credit_type_id` of `2714e483-4ff1-48e4-9e25-ac732e8f24f2` represents USD, where values are in **cents** (for example, a `threshold` of `10000` = \$100.00). Other supported currencies use whole units. See [currency denomination](/guides/pricing-packaging/make-pricing-changes/use-currency-custompricingunits#currency-denomination) for details. Spend notifications are not limited to USD — you can set them in custom pricing units, which you can define on the **Offering** page in the [Metronome app](https://app.metronome.com/offering/pricing-units/custom-pricing-units). ### Process notifications sent through a webhook​ Taking action on notifications in real time requires the use of webhooks—dedicated endpoints in your application for receiving and processing notifications. Configure webhooks in Metronome in under [Developer - Notifications - Webhooks](https://app.metronome.com/developer/notifications/webhooks). When a notification triggers in Metronome, a POST request is sent to your webhook with basic information related to the notification, including the type, customer ID, and alert ID. Upon receiving a webhook notification, your application can process it and take the appropriate action. Learn more best practices around handling [webhook notifications](/guides/platform-configuration/webhooks/best-practices). For the spend limit example above, processing the webhook payload might look like this: 1. Check that the alert ID matches a threshold notification you have configured and that the customer ID matches the one you associated with the alert ID. 2. Using information included in the webhook like alert ID, name, and threshold, determine whether the customer exceeded their soft limit, or their hard limit. 3. If the customer exceeded their soft limit, notify the customer inside the app, through email, or via your preferred delivery mechanism. 4. If the customer exceeded their hard limit, disable the customer’s access to your services to prevent any additional spend. Inform the customer they have reached their hard spend limit and prompt them to update their limits in your application if they’d like to continue using the service. 5. For any limits that have changed, archive the previous notifications before creating new notifications with the updated thresholds: ```bash theme={null} curl https://api.metronome.com/v1/alerts/archive \ -H "Authorization: Bearer " \ -H "Content-Type: application/json" \ -d '{ "id": "e9c0d89d-040e-4ffc-91f6-001c6954d7a7" }' ``` In addition to using webhook notifications, you can regularly check the status of customer notifications at any time that makes sense in the customer workflow, such as upon initial login. Do this with calls to the [/customer-alerts/get](/api-reference/alerts/get-an-alert) endpoint for a specific threshold notification, or the [/customer-alerts/list](/api-reference/alerts/list-customer-alerts) endpoint for all threshold notifications. ### Enable custom spend limits for a specific dimension​ Your customers may want the flexibility to set up custom spend limits for a subset of usage. For example, they may want to receive a notification or limit access when a specific `user_id` has spent more than \$500 in a billing period, or when any `organization_id` has spent more than \$5000. In Metronome, you have the option of adding `group_values` filters to spend threshold notifications to support this use case. Create a notification on spend for `user_id` = `user_123` using the following API call: ```bash theme={null} curl https://api.metronome.com/v1/alerts/create \ -d '{ "alert_type": "spend_threshold_reached", "credit_type_id": "2714e483-4ff1-48e4-9e25-ac732e8f24f2", "name": "$500 spend limit for user_123", "threshold": 50000, "customer_id": "5cceec38-51fe-4399-8bed-fcb2a8ad1fb7", "group_values":[{"key":"user_id", "value":"user_123"}] }' ``` Create a threshold notification on spend for any `organization_id` using the following API call. If any `organization_id` spends more than \$5000, you will receive a webhook notification, including which `organization_id` breached the threshold in the payload. ```bash theme={null} curl https://api.metronome.com/v1/alerts/create \ -H "Authorization: Bearer " \ -H "Content-Type: application/json" \ -d '{ "alert_type": "spend_threshold_reached", "credit_type_id": "2714e483-4ff1-48e4-9e25-ac732e8f24f2", "name": "$5000 spend limit for any organization", "threshold": 500000, "customer_id": "5cceec38-51fe-4399-8bed-fcb2a8ad1fb7", "group_values":[{"key":"organization_id"}] }' ``` To retrieve an customer threshold notification for any `organization_id` (e.g. `finance`), use the [/customer-alerts/get](/api-reference/alerts/get-an-alert) endpoint. ```bash theme={null} curl https://api.metronome.com/v1/customer-alerts/get \ -H "Authorization: Bearer " \ -H "Content-Type: application/json" \ -d '{ "customer_id": "5cceec38-51fe-4399-8bed-fcb2a8ad1fb7", "alert_id": "e9c0d89d-040e-4ffc-91f6-001c6954d7a7" "group_values": [{"key":"organization_id", "value":"finance"}] }' ``` In order to use a key in the `group_values` field, make sure that key is added as a [group key](/guides/get-started/core-concepts/create-billable-metrics#3-define-group-keys) on billable metrics associated with that customer's contract. Spend on products where the key is not a group key on the underlying billable metrics will not contribute to the threshold. When evaluating spend threshold notifications for a specific dimension, Metronome recomputes the invoice as if the group key is a presentation group key. In cases with tiered pricing, quantity rounding, or MAX billable metrics, the pricing and packaging will be applied to the subset of usage you define. For example, if you create a threshold notification for `organization_id` = `finance`, the quantity will be rounded for the subset of usage by the finance org. > [!NOTE] > > INFO > > For a given customer, you can set spend threshold notifications for three keys. For example, you can set spend threshold notifications for a `user_id`, a `project_id`, and an `organization_id`, but will be prevented from adding a notification using a fourth key. For keys with more than 5000 values for a given customer, contact us via the [Metronome support portal](https://app.metronome.com/support) to discuss your spend threshold notification configuration. ## Monitor commit balance​ Another useful scenario for flexible notification management is helping customers monitor the balance related to a contractually established spend commit. This example assumes you have set up products, rates, contracts, and commits in Metronome and want to allow a customer to specify a commitment balance at which they want to receive a notification. See the following call below: ```bash theme={null} curl https://api.metronome.com/v1/alerts/create \ -H "Authorization: Bearer " \ -H "Content-Type: application/json" \ -d '{ "alert_type": "low_remaining_commit_balance_reached", "credit_type_id": "2714e483-4ff1-48e4-9e25-ac732e8f24f2", "name": "Commitment Balance Alert", "threshold": 500, "customer_id": "5cceec38-51fe-4399-8bed-fcb2a8ad1fb7" }' ``` This gives you an opportunity to notify your customer that they’re reaching the end of their commit, or even send a message to your sales team to contact this customer for a potential renegotiation. It also provides a trigger for cutting off access if appropriate when the commit balance reaches zero. ## Enable custom invoice total limits​ The [spend threshold reached](/guides/customers-billing/set-up-notifications/create-and-manage-notifications#spend-alerts) notification described above uses a customer's usage-based spend prior to credit and commit drawdown. You can also set notifications on invoice total. The invoice total is evaluated after credit and commit drawdown and corresponds to the amount a customer will pay. To allow a customer to specify an invoice total reached threshold notification on usage invoices, see the following call: ```bash theme={null} curl https://api.metronome.com/v1/alerts/create \ -H "Authorization: Bearer bb842ce6470ef5fc9982b861b53c0b7c3c111ac34b7980b38b70c095e77de2c4" \ -H "Content-Type: application/json" \ -d '{ "alert_type": "invoice_total_reached", "credit_type_id": "2714e483-4ff1-48e4-9e25-ac732e8f24f2", "name": "$100 usage invoice total reached alert", "threshold": 10000, "customer_id": "5cceec38-51fe-4399-8bed-fcb2a8ad1fb7", "invoice_types_filter": ["USAGE"] }' ``` # Build API-powered customer dashboards Source: https://docs.metronome.com/guides/customers-billing/optimize-customer-experience/customer-dashboards-and-reporting This use case walks through examples for how to build an API-powered customer dashboard. Metronome integrates with your core product by providing cost visibility to end customers. This helps them optimize usage patterns and derive maximum value from your product. With your usage-based offerings, customers expect transparency into their consumption and associated costs. Metronome's APIs and data export features integrate with your product, enabling you to create end-user dashboards that provide this critical visibility. ## Interactive demo Explore a fully working reference dashboard built on the Metronome API. This example dashboard shows how you can display usage tracking, credit balance management, invoice history, and self-serve controls, powered by the same endpoints documented below. [Open demo dashboard →](/guides/customers-billing/demo-dashboard/app) ## Show customers data they want to see Customer dashboards provide essential insights into resource consumption and cost management: a critical customer interface with your product. Customers want to understand their usage patterns so they can make informed decisions around their usage and build trust that they're getting metered accurately. Excellent customer dashboards that delight customers often share similar characteristics: * **Granular usage visibility** Customers want to decompose their usage by product or feature to better understand their biggest cost centers and reallocate usage when needed. * **Up-to-date spend visibility** Customers want to see how much in spend they’ve already accumulated for their current billing period before getting charged, preventing surprises at the end of the billing period. * **Commitment tracking** Customers want to know the available balance for their current commits to plan their usage and proactively purchase new commits. * **Build trust** Customers expect high precision in metering their usage. Providing transparency into the rating process in real time builds confidence that this expectation is met. You can accomplish all of the above outcomes for your customer dashboards by building directly off of the Metronome API. Metronome also provides out-of-the-box embeddable dashboards that show a customer's usage and invoices. ## Use Metronome APIs to power customer-facing dashboards Metronome offers several API endpoints that provide data useful for powering dashboards that your customers want to see. This section explores a few of these endpoints. For assistance in designing your customer dashboard with Metronome APIs, contact us via the [Metronome support portal](https://app.metronome.com/support). ### Backend integration pattern best practice When integrating Metronome data into your application to expose to your end users, you must ensure that all Metronome APIs get called from one of your backend services to return data to your frontend application. Implement all authentication against Metronome using a securely stored [token](/api-reference/authorization) available to your backend service. Never expose Metronome API tokens to users or use them on frontend clients. ``` Your Frontend App <--> Your Backend Service <--> Metronome APIs ``` ### Display granular usage visibility One way to enhance your customer's experience is to provide them with visibility of their usage in real-time. Metronome can slice and filter this usage based on any of your event properties, enabling highly granular analysis. This transparency enables them to derive insights into their usage patterns, previously unknown to them, and take action. For example, by viewing their usage mid-month, a customer might realize that certain servers they spun up consume a disproportionately greater amount of memory than in previous months. This insight enables them to assess their own internal processes and identify potential optimizations. To explore how you can create this, consider the following example: create a bar chart that filters down to usage of a particular metric over time. ![Display granular usage visibility](https://mintcdn.com/metronome-b35a6a36/EFj4IzRwX7Op9TX1/images/optimize-customer-experience/usage-visibility-fdce11566d08bbcc48965b1e813ab849.png?fit=max\&auto=format\&n=EFj4IzRwX7Op9TX1\&q=85\&s=b784015e3251e6274db34023b96b5953) The Metronome [usage endpoint](/api-reference/usage/get-batched-usage-data) provides the foundation for showing users visibility into usage from each of their billable metrics over time. For example, this request shows daily usage from the `CPU hours` billable metric over the month of October 2024, broken out by region: ```bash theme={null} curl https://api.metronome.com/v1/usage \ -H "Authorization: Bearer " \ -H "Content-Type: application/json" \ -d '{ "customer_id": "140a7113-76c4-4ce2-9379-29fa3375d23c", "billable_metric_id": "f3b17844-a98d-413a-b310-5be1df72213d", "starting_on": "2024-10-01T00:00:00Z", "ending_before": "2024-11-01T00:00:00Z", "window_size": "day", "group_by": { "key": "region" } }' ``` An example response to this request looks like: > [accordion] View response > > ```json theme={null} > { > "data": [ > { > "value": 37, > "group_key": "region", > "group_value": "ap-south-1", > "starting_on": "2024-10-01T00:00:00+00:00", > "ending_before": "2024-10-02T00:00:00+00:00" > }, > { > "value": 24, > "group_key": "region", > "group_value": "us-east-1", > "starting_on": "2024-10-01T00:00:00+00:00", > "ending_before": "2024-10-02T00:00:00+00:00" > }, > { > "value": 12, > "group_key": "region", > "group_value": "us-east-2", > "starting_on": "2024-10-01T00:00:00+00:00", > "ending_before": "2024-10-02T00:00:00+00:00" > }, > { > "value": 91, > "group_key": "region", > "group_value": "ap-south-1", > "starting_on": "2024-10-02T00:00:00+00:00", > "ending_before": "2024-10-03T00:00:00+00:00" > } > ], > "next_page": null > } > ``` Use this pseudocode to pull together data from the Metronome usage endpoint in your backend and present it to users as a stacked bar chart in your frontend. ```python Backend theme={null} # Step 1: Extract the data from the API response data = metronome_api_response['data'] # Step 2: Create a dictionary to store the processed data processed_data = {} # Step 3: Iterate through the data and organize it by date and region for item in data: date = item['starting_on'] region = item['group_value'] value = item['value'] if date not in processed_data: processed_data[date] = {} processed_data[date][region] = value # Step 4: Create a list of unique regions and sort them regions = sorted(set(item['group_value'] for item in data)) # Step 5: Prepare the data for charting chart_data = [] for date in sorted(processed_data.keys()): data_point = {'date': date} cumulative_value = 0 for region in regions: value = processed_data[date].get(region, 0) data_point[f"{region}_start"] = cumulative_value cumulative_value += value data_point[f"{region}_end"] = cumulative_value chart_data.append(data_point) # Return chart data for frontend chart library usage return chart_data ``` ```javascript Frontend theme={null} # Step 1: Fetch billable metric chart data from your backend (from above) chart_data = fetch_from_backend('/api/customer_usage/:customer_id') # Step 2: Use the chart_data to create your stacked bar chart # The exact implementation depends on your charting library # Example using a hypothetical charting library: create_stacked_bar_chart( data=chart_data, x_axis='date', y_axis='value', stacks=regions, colors=['blue', 'red', 'green'], # Assign colors to each region title='Usage by Region Over Time' ) ``` ### Display commitment tracking Inside of Metronome, you can view a ledger of each commit and credit. This offers visibility into current balance and the events that contributed to it. You can imagine that your end customers would also benefit from this visibility to understand their remaining balance on a specific credit or commit. This can help inform their decision-making, such as purchasing a new commit or throttling their usage to stay within their remaining allotment. This example table shows how you could display this information to your customer: ![Commitment tracking](https://mintcdn.com/metronome-b35a6a36/C_lGxKgdkdHt6xoX/images/optimize-customer-experience/commitment-tracking-ad8d69832510b0565b8fea1ce51e8d97.png?fit=max\&auto=format\&n=C_lGxKgdkdHt6xoX\&q=85\&s=bc6fa2cf97373149ae5649056a6b29ae) Use the Metronome [`/listBalances`](/api-reference/credits-and-commits/list-balances) endpoint to understand the current state of a customer's balance across commits and credits. For example, consider a customer that has: * Received a prepaid commit of \$100, starting on September 1st, 2024. * Received a free reward credit for \$5, starting on October 1st, 2024. The free credit should be used in full before the remaining prepaid commit gets burned down. * Spent \$65 in the month of September. * Spent \$20 in the month of October. In this scenario, the customer has the following balances remaining: * Reward credit: \$0 remaining, \$5 used * Prepaid commit: \$20 remaining, \$80 used * Overall balance: \$20 remaining, \$85 used Use the `/listBalances` endpoint to retrieve information about the prepaid commit and bonus credit from September 1st onward in one response. Because the request includes the `include_balance: true` parameter, for each commit or credit a `balance` field returns that reflects the amount of commit or credit available to use now. Note that any upcoming, not-yet-started commit or credit segments are not included in this balance as they are not available to use. ```bash theme={null} curl -X POST https://api.metronome.com/v1/contracts/customerBalances/list \ -H "Authorization: Bearer " \ -H "Content-Type: application/json" \ -d '{ "customer_id": "23f894af-c350-45df-bb3e-3b134e352109", "include_ledgers": true, "include_balance": true, "starting_at": "2024-09-01T00:00:00Z", "include_contract_balances": true }' ``` > [accordion] View response > > ```json theme={null} > { > "data": [ > { > "id": "b8bc055d-2c0f-4629-b9e4-c87e0b59da1e", > "contract": { > "id": "8b6cb03d-c9c7-4230-9656-ed8e106bc7bd" > }, > "product": { > "id": "d72716a4-1dcc-4e91-8ad4-a1be29c917a7", > "name": "Prepaid Credits" > }, > "priority": 100, > "applicable_contract_ids": ["8b6cb03d-c9c7-4230-9656-ed8e106bc7bd"], > "access_schedule": { > "credit_type": { > "id": "2714e483-4ff1-48e4-9e25-ac732e8f24f2", > "name": "USD (cents)" > }, > "schedule_items": [ > { > "id": "e20d07a1-63c0-4fef-ac23-50f7b710cf3e", > "amount": 10000, > "starting_at": "2024-09-01T00:00:00+00:00", > "ending_before": "2025-09-01T00:00:00+00:00" > } > ] > }, > "balance": 2000, > "ledger": [ > { > "amount": 10000, > "timestamp": "2024-09-01T00:00:00+00:00", > "segment_id": "e20d07a1-63c0-4fef-ac23-50f7b710cf3e", > "type": "PREPAID_COMMIT_SEGMENT_START" > }, > { > "amount": -6500, > "timestamp": "2024-10-01T00:00:00+00:00", > "segment_id": "e20d07a1-63c0-4fef-ac23-50f7b710cf3e", > "type": "PREPAID_COMMIT_AUTOMATED_INVOICE_DEDUCTION", > "invoice_id": "3f13f349-c1a6-5e98-81ce-fd3743904e6f" > }, > { > "amount": -1500, > "timestamp": "2024-11-01T00:00:00+00:00", > "segment_id": "e20d07a1-63c0-4fef-ac23-50f7b710cf3e", > "type": "PREPAID_COMMIT_AUTOMATED_INVOICE_DEDUCTION", > "invoice_id": "832ed401-17ed-56dd-87c4-b5684a52b26c" > } > ], > "custom_fields": {}, > "type": "PREPAID", > "invoice_schedule": { > "credit_type": { > "id": "2714e483-4ff1-48e4-9e25-ac732e8f24f2", > "name": "USD (cents)" > }, > "schedule_items": [ > { > "id": "a528d105-4a7c-4a93-b630-56ccf8a675d5", > "invoice_id": "0267436e-3c4d-5ee4-9369-5618f27229a5", > "amount": 10000, > "unit_price": 10000, > "quantity": 1, > "timestamp": "2024-09-01T00:00:00+00:00" > } > ] > } > }, > { > "id": "c0522458-353f-4a39-bad2-a315ff2eed88", > "contract": { > "id": "8b6cb03d-c9c7-4230-9656-ed8e106bc7bd" > }, > "product": { > "id": "aa52ce3b-f896-4f5c-b1ec-a71dff8ebfeb", > "name": "Reward credit" > }, > "priority": 1, > "applicable_contract_ids": ["8b6cb03d-c9c7-4230-9656-ed8e106bc7bd"], > "access_schedule": { > "credit_type": { > "id": "2714e483-4ff1-48e4-9e25-ac732e8f24f2", > "name": "USD (cents)" > }, > "schedule_items": [ > { > "id": "3b4be61d-26d0-46a5-acb5-c55d5cce0d9c", > "amount": 500, > "starting_at": "2024-10-01T00:00:00+00:00", > "ending_before": "2024-11-01T00:00:00+00:00" > } > ] > }, > "balance": 0, > "ledger": [ > { > "amount": 500, > "timestamp": "2024-10-01T00:00:00+00:00", > "segment_id": "3b4be61d-26d0-46a5-acb5-c55d5cce0d9c", > "type": "CREDIT_SEGMENT_START" > }, > { > "amount": -500, > "timestamp": "2024-11-01T00:00:00+00:00", > "segment_id": "3b4be61d-26d0-46a5-acb5-c55d5cce0d9c", > "type": "CREDIT_AUTOMATED_INVOICE_DEDUCTION", > "invoice_id": "832ed401-17ed-56dd-87c4-b5684a52b26c" > } > ], > "custom_fields": {}, > "type": "CREDIT" > } > ], > "next_page": null > } > ``` Use this pseudocode to pull together the data from the Metronome `/listBalances` endpoint in your backend and present it to end users as a stacked bar chart in your frontend. ```python Backend theme={null} # Step 1: Extract the data from the Metronome API response data = metronome_api_response['data'] # Step 2: Initialize variables for overall totals total_granted = 0 total_used = 0 # Step 3: Process each grant processed_grants = [] for item in data: grant_id = item['id'] grant_type = item['type'] product_name = item['product']['name'] # Calculate total granted for this item granted = sum(schedule_item['amount'] for schedule_item in item['access_schedule']['schedule_items']) # Get remaining amount remaining = item['balance'] # Calculate used amount used = granted - remaining # Add to overall totals total_granted += granted total_used += used # Add grant info to list processed_grants.append({ 'id': grant_id, 'type': grant_type, 'product_name': product_name, 'granted': granted, 'used': used, 'remaining': remaining }) # Step 4: Calculate total remaining total_remaining = total_granted - total_used # Step 5: Prepare result result = { 'grants': processed_grants, 'total': { 'granted': total_granted, 'used': total_used, 'remaining': total_remaining } } # Step 6: Return processed data for frontend use return result ``` ```javascript Frontend theme={null} # Step 1: Fetch processed credit and commit data from backend processed_data = fetch_from_backend('/api/credit_commit_data/:customer_id') # Step 2: Display individual grants for grant in processed_data['grants']: display_grant_info(grant) # Step 3: Display overall totals display_overall_totals(processed_data['total']) ``` Additionally, you may want to show a running total of the remaining balance to your customer on a general overview page, without the ledger detail. Metronome offers an ergonomic way to pull a total remaining balance in these scenarios. For example, you may have heard feedback that customers want to understand their remaining balance on the home page of your app, without needing to click into the detailed billing view to understand their detailed commit and credit drawdowns. In this case you can make a straightforward call to the [`/getNetBalance`](https://docs.metronome.com/api-reference/credits-and-commits/get-the-net-balance-of-a-customer) endpoint. The following call would return the real-time balance without needing to parse through individual balance details. ```bash theme={null} curl -X POST https://api.metronome.com/v1/contracts/customerBalances/getNetBalance \ -H "Authorization: Bearer " \ -H "Content-Type: application/json" \ -d '{ "customer_id": "23f894af-c350-45df-bb3e-3b134e352109" }' ``` ### Display up-to-date spend While the usage dashboard helps derive granular insights into usage patterns, often times this isn't the full story. Your customers also want to understand the associated costs of their usage. This helps them contextualize their analysis by understanding the potential cost savings associated with potential process or architectural changes. Additionally, it eliminates the potential of a surprise at the end of the month when they receive their invoice, which can mitigate the risk of potential disputes. To articulate a customer's cost, create a dashboard inside of your product that shows spend over time, segmented by certain properties. For example, spend by region over time: ![Display up-to-date spend](https://mintcdn.com/metronome-b35a6a36/EFj4IzRwX7Op9TX1/images/optimize-customer-experience/up-to-date-spend-79da8c8a70745d80275b7d649789844e.png?fit=max\&auto=format\&n=EFj4IzRwX7Op9TX1\&q=85\&s=0eb2e47a1182002c6ce818bc87314288) Use the Metronome [invoice breakdown endpoint](/api-reference/invoices/list-invoice-breakdowns) to view spend over a given time window. The invoice breakdown endpoint gets returned for each line item on a customer's invoice in hourly or daily buckets. If commits or credits get consumed against certain line items during the period, they display as separate line items to mark the deductions for the amount of credits used. For example, this request generates a customer's daily spend across all line items for the month of October 2024. In this example a customer doesn't burn against any set of credits or commits and only pays in arrears. ```bash theme={null} curl https://api.metronome.com/v1/customers/d7abd0cd-4ae9-4db7-8676-e986a4ebd8dc/invoices/breakdowns?starting_on=2024-10-01T00%3A00%3A00Z&ending_before=2024-11-01T00%3A00%3A00Z&window_size=day \ -H "Authorization: Bearer " \ -H "Content-Type: application/json" ``` > [accordion] View response > > ```json theme={null} > { > "data": [ > { > "id": "c5b9aab9-377b-517d-a634-924e35e7d110", > "issued_at": "2024-11-02T00:00:00+00:00", > "start_timestamp": "2024-10-01T00:00:00+00:00", > "end_timestamp": "2024-11-01T00:00:00+00:00", > "customer_id": "140a7113-76c4-4ce2-9379-29fa3375d23c", > "customer_custom_fields": {}, > "type": "USAGE", > "credit_type": { > "id": "2714e483-4ff1-48e4-9e25-ac732e8f24f2", > "name": "USD (cents)" > }, > "status": "DRAFT", > "total": 7300, > "external_invoice": null, > "contract_id": "28d9bc16-7c56-4d4a-a2b9-b4c3ede34eeb", > "contract_custom_fields": {}, > "line_items": [ > { > "product_id": "d111fa1e-861e-48bb-82a6-3924d6cf0636", > "product_type": "UsageProductListItem", > "product_custom_fields": {}, > "name": "My Product", > "total": 3700, > "credit_type": { > "id": "2714e483-4ff1-48e4-9e25-ac732e8f24f2", > "name": "USD (cents)" > }, > "starting_at": "2024-10-01T00:00:00+00:00", > "ending_before": "2024-11-01T00:00:00+00:00", > "unit_price": 100, > "quantity": 37, > "presentation_group_values": { > "region": "ap-south-1" > } > }, > { > "product_id": "d111fa1e-861e-48bb-82a6-3924d6cf0636", > "product_type": "UsageProductListItem", > "product_custom_fields": {}, > "name": "My Product", > "total": 2400, > "credit_type": { > "id": "2714e483-4ff1-48e4-9e25-ac732e8f24f2", > "name": "USD (cents)" > }, > "starting_at": "2024-10-01T00:00:00+00:00", > "ending_before": "2024-11-01T00:00:00+00:00", > "unit_price": 100, > "quantity": 24, > "presentation_group_values": { > "region": "us-east-1" > } > }, > { > "product_id": "d111fa1e-861e-48bb-82a6-3924d6cf0636", > "product_type": "UsageProductListItem", > "product_custom_fields": {}, > "name": "My Product", > "total": 1200, > "credit_type": { > "id": "2714e483-4ff1-48e4-9e25-ac732e8f24f2", > "name": "USD (cents)" > }, > "starting_at": "2024-10-01T00:00:00+00:00", > "ending_before": "2024-11-01T00:00:00+00:00", > "unit_price": 100, > "quantity": 12, > "presentation_group_values": { > "region": "us-east-2" > } > } > ], > "custom_fields": {}, > "billable_status": "billable", > "breakdown_start_timestamp": "2024-10-01T00:00:00.000Z", > "breakdown_end_timestamp": "2024-10-02T00:00:00.000Z" > } > ], > "next_page": null > } > ``` If you update the scenario above to show the customer burning down against a \$200 prepaid commit, you see the commit deductions represented in the breakdown in addition to the usage line items. Use these fields if you want to show credit and commit burndown over time. > [accordion] View response > > ```json theme={null} > { > "data": [ > { > "id": "5d960878-2553-5290-bddd-8def5f42532a", > "issued_at": "2024-11-02T00:00:00+00:00", > "start_timestamp": "2024-10-01T00:00:00+00:00", > "end_timestamp": "2024-11-01T00:00:00+00:00", > "customer_id": "140a7113-76c4-4ce2-9379-29fa3375d23c", > "customer_custom_fields": {}, > "type": "USAGE", > "credit_type": { > "id": "2714e483-4ff1-48e4-9e25-ac732e8f24f2", > "name": "USD (cents)" > }, > "status": "DRAFT", > "total": 0, > "external_invoice": null, > "contract_id": "95a390e3-b5c6-4264-8c7a-3583ec574c42", > "contract_custom_fields": {}, > "line_items": [ > { > "product_id": "d111fa1e-861e-48bb-82a6-3924d6cf0636", > "product_type": "UsageProductListItem", > "product_custom_fields": {}, > "name": "My Product", > "total": 3700, > "credit_type": { > "id": "2714e483-4ff1-48e4-9e25-ac732e8f24f2", > "name": "USD (cents)" > }, > "starting_at": "2024-10-01T00:00:00+00:00", > "ending_before": "2024-11-01T00:00:00+00:00", > "commit_id": "f3243ab9-dd22-4a6e-b4c3-7b2a0f8e8732", > "commit_segment_id": "ede54bc6-0c23-4d0b-a096-d6c79f38ff31", > "commit_type": "PrepaidCommit", > "commit_custom_fields": {}, > "unit_price": 100, > "quantity": 37, > "presentation_group_values": { > "region": "ap-south-1" > } > }, > { > "product_id": "d111fa1e-861e-48bb-82a6-3924d6cf0636", > "product_type": "UsageProductListItem", > "product_custom_fields": {}, > "name": "Prepaid Credits applied", > "total": -3700, > "credit_type": { > "id": "2714e483-4ff1-48e4-9e25-ac732e8f24f2", > "name": "USD (cents)" > }, > "starting_at": "2024-10-01T00:00:00+00:00", > "ending_before": "2024-11-01T00:00:00+00:00", > "commit_id": "f3243ab9-dd22-4a6e-b4c3-7b2a0f8e8732", > "commit_segment_id": "ede54bc6-0c23-4d0b-a096-d6c79f38ff31", > "commit_type": "PrepaidCommit", > "commit_custom_fields": {} > } > ], > "custom_fields": {}, > "billable_status": "billable", > "breakdown_start_timestamp": "2024-10-01T00:00:00.000Z", > "breakdown_end_timestamp": "2024-10-02T00:00:00.000Z" > } > ], > "next_page": null > } > ``` Use this pseudocode to pull together data from the Metronome invoice breakdown endpoint in your backend and present it to users as a stacked bar chart in your frontend. ```python Backend theme={null} # Step 1: Extract the data from the Metronome API response data = metronome_api_response['data'] # Step 2: Create a dictionary to store the processed data processed_data = {} # Step 3: Iterate through the data and organize it by date and region for item in data: date = item['breakdown_start_timestamp'] for line_item in item['line_items']: region = line_item['presentation_group_values']['region'] value = line_item['total'] / 100 # Convert cents to dollars if date not in processed_data: processed_data[date] = {} if region not in processed_data[date]: processed_data[date][region] = 0 processed_data[date][region] += value # Step 4: Create a list of unique regions and sort them regions = sorted(set(region for date_data in processed_data.values() for region in date_data.keys())) # Step 5: Prepare the data for charting chart_data = [] for date in sorted(processed_data.keys()): data_point = {'date': date} for region in regions: data_point[region] = processed_data[date].get(region, 0) chart_data.append(data_point) # Return chart data for frontend chart library usage return chart_data ``` ```javascript Frontend theme={null} # Step 1: Fetch spend over time chart data from your backend chart_data = fetch_from_backend('/api/customer_spend/:customer_id') # Step 2: Extract unique regions from the chart data regions = list(set(key.split('_')[0] for key in chart_data[0].keys() if key.endswith('_start'))) # Step 3: Use the chart_data to create your stacked bar chart # The exact implementation depends on your charting library # Example using Chart.js: create_stacked_bar_chart( data=chart_data, x_axis='date', y_axis='Spend (USD)', stacks=regions, colors=['#4e79a7', '#f28e2c', '#e15759'], # Assign colors to each region title='Spend by Region Over Time' ) ``` ## Embeddable dashboards Share Metronome invoices and usage data with your customers through customizable embeddable dashboards. ### Invoice Dashboard The invoice dashboard allows your customers to view their current and historical invoices (draft, finalized, and voided), up to 90 days old. ![Invoice dashboard screenshot](https://mintcdn.com/metronome-b35a6a36/C_lGxKgdkdHt6xoX/images/optimize-customer-experience/embed-invoice-dashboard-d7f7d0437f79ff47d7fb1ef59c7b0494.png?fit=max\&auto=format\&n=C_lGxKgdkdHt6xoX\&q=85\&s=7af99751ce28ec6bbbe1dae1a182dee3) Filter the invoices returned using the `dashboard_options` array, which has the following optional parameters: * `show_zero_usage_line_items`: Configure whether line items with zero quantity are shown on the invoice. Defaults to false. * `contract_id`: For customers with multiple contracts, display only the invoices on a specific contract. Defaults to all. * `invoice_type`: Display invoices by type to show only usage invoices or only scheduled (subscription, commit purchase, or scheduled charge invoices). Defaults to all. * `invoice_status_filter`: Display invoices by status ("VOID", "FINALIZED", "DRAFT", "FINALIZED\_AND\_DRAFT", or "ALL"). Defaults to all. ### Usage dashboard The usage dashboard shows usage metrics attached to a customer's current contract for the past 30, 60, or 90 days. ![Usage dashboard screenshot](https://mintcdn.com/metronome-b35a6a36/EFj4IzRwX7Op9TX1/images/optimize-customer-experience/embed-usage-dashboard-9bdb8b6e399a006c498765506e018ca9.png?fit=max\&auto=format\&n=EFj4IzRwX7Op9TX1\&q=85\&s=3b5cde91dfff0508ecd8d56af89a8ffc) ### Commits and credits dashboard The commits and credits dashboard allows your customers to view their current and historical commit and credit grants, including: * Remaining and historical balances * Grant and deduction history * Access schedules and expiration dates ![Commits and credits dashboard screenshot](https://mintcdn.com/metronome-b35a6a36/C_lGxKgdkdHt6xoX/images/optimize-customer-experience/embed-commits-and-credits-dashboard-31100d4112d26f01012abcebef08dda4.png?fit=max\&auto=format\&n=C_lGxKgdkdHt6xoX\&q=85\&s=ca2ebc5369e89ee6d96890af06b3c6db) ### Embed a dashboard Use the Metronome API to retrieve an embeddable dashboard URL which can be displayed through an iframe within your internal billing UI. 1. Create an [API token](/api-reference/authorization) (if you don't already have one) 2. Use the [`/dashboards/getEmbeddableUrl`](/api-reference/customers/get-an-embeddable-customer-dashboard) endpoint to pass the `customer_id` and specify the dashboard you want to display. ### Override the color palette The `/dashboards/getEmbeddableUrl` endpoint supports a `color_overrides` array to override the color palette and match your design. See the full [list of colors](/api-reference/customers/get-an-embeddable-customer-dashboard). The image demonstrates where Metronome uses each named color. For example, `gray_dark` applies to standard text; `primary_medium` applies to selected text. ![Dashboard style guide for invoice dashboard](https://mintcdn.com/metronome-b35a6a36/C_lGxKgdkdHt6xoX/images/optimize-customer-experience/embed-style-guide-invoice-e2934a0c3c5f3dc8435e75c0cfa96e8a.png?fit=max\&auto=format\&n=C_lGxKgdkdHt6xoX\&q=85\&s=6c9457039468a6c19eab0d0cf5870848) # Track the remaining balance of a credit or commit Source: https://docs.metronome.com/guides/customers-billing/optimize-customer-experience/get-remaining-balance Tracking the remaining balance of credits and commits helps you accurately understand account health, forecast revenue, and track assets and liabilities. It also supports providing customers with up-to-date information on their remaining balance. There are many ways to display remaining balance to customers and Metronome provides the flexibility to display both aggregated and detailed views. > [!WARNING] > > Balance values can be **fractional numbers** (e.g., `0.8` cents for USD). When integrating with the balances API, do not truncate balances to integers — doing so may cause data loss. Rounding is acceptable if done intentionally. For USD, amounts are denominated in cents, so a balance of `0.8` represents \$0.008. ## Fetch the total remaining balance on a customer To display an aggregated real-time balance to your customers, call the [`/getNetBalance`](https://docs.metronome.com/api-reference/credits-and-commits/get-the-net-balance-of-a-customer) endpoint. This endpoint returns a single aggregated sum of the remaining balance on a customer, with advanced filtering by balance type, currency, pending charges, and custom fields. ## Build a detailed ledger view of individual balances Metronome also supports more detailed views of individual balances by tracking ledger entries using the [`listBalances`](https://docs.metronome.com/api-reference/credits-and-commits/list-balances) endpoint. Each credit or commit is associated with a ledger, which records events that change the balance of the commit or credit. Adding all of the entries in a ledger results in the total remaining balance associated with that ledger. For example, there are ledger entries associated with the `access_schedule` beginning, invoice deductions (drawdowns of the credit or commit corresponding to usage), and expirations. Each ledger entry is associated with a `type`, an `amount` (which can be positive or negative), and an effective `timestamp`. There is one invoice deduction ledger entry for each invoice that consumes a credit or commit. The `timestamp` associated with invoice deduction ledger entries is always the end of the service period associated with the usage invoice. Use the `timestamp` to show customers their remaining balance including pending charges, or excluding pending charges. ### Example ledger Consider an example where a customer is issued a \$100 credit with one access segment from September 01, 2024 through October 01, 2024. During the month of September, the customer consumed \$63 of the credit. The remaining credit balance expired after October 01. As a result, this credit has three ledger entries: > [card] > > > > > > > > > > > > > > > > > > > > > > > > > > > > > >
TypeTimestampAmount
`credit_segment_start`9/1/2024+\$100
`credit_automated_invoice_deduction`10/1/2024-\$63
`credit_segment_expiration`10/1/2024-\$37
### Manual ledger entries You may want to adjust a credit or commit's ledger to account for mistakes, migrate existing customers with outstanding balances to Metronome, or many other reasons. Apply positive or negative adjustments to a credit or commit's ledger through the [Metronome app](https://app.metronome.com/) or API using the [`/addManualBalanceLedgerEntry`](/api-reference/credits-and-commits/add-a-manual-balance-entry) endpoint. ### Credit ledger entry types > [card] > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > >
TypeDescription
`credit_segment_start`Represents that a credit segment started and the customer now has access to the usage amount for that segment. The access schedule of the credit describes these segments.
`credit_automated_invoice_deduction`Represents deductions from the credit segment caused by a usage invoice that included usage applicable to this credit.
`credit_segment_expiration`Represents the unused credit amount that expired at the end of a credit segment.
`credit_manual`Represents a manual ledger entry added to a credit.
`credit_seat_based_adjustment`Represents the additional credit associated with a seat increment when using recurring credits linked to a subscription
### Commit ledger entry types > [card] > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > >
TypeDescription
`postpaid_initial_balance`Represents the starting balance of a postpaid commit.
`postpaid_automated_invoice_deduction`Represents deductions from the remaining obligation of the postpaid commit as the result of an invoice with usage that applies to this commit.
`postpaid_trueup`Represents a true-up invoice issued for this commit to cover usage not covered by automated usage invoices.
`postpaid_rollover`Represents unused usage from the postpaid commit which was rolled over to a new contract.
`postpaid_manual`Represents a manual ledger entry added to a postpaid commit.
`postpaid_commit_expiration`Represents commit amount unused and expired at the end of a commit segment. Does not include usage that rolled over to a new contract.
`prepaid_segment_start`Represents that a prepaid commit segment started and the customer now has access to the usage amount for that segment. The access schedule of the prepaid commit describes these segments.
`prepaid_automated_invoice_deduction`Represents deductions from the prepaid commit segment caused by a usage invoice that included usage applicable to this commit.
`prepaid_rollover`Represents unused usage from the prepaid commit that rolled over to a new contract.
`prepaid_segment_expiration`Represents commit amount unused and expired at the end of a commit segment. Does not include usage that rolled over to a new contract.
`prepaid_commit_expiration`Represents commit amount unused and expired at the end of a commit segment. Does not include usage that rolled over to a new contract.
`prepaid_manual`Represents a manual ledger entry added to a prepaid commit.
`prepaid_commit_seat_based_adjustment`Represents the additional commit associated with a seat increment when using recurring commits linked to a subscription
# India e-mandate support for Stripe invoices Source: https://docs.metronome.com/guides/customers-billing/optimize-customer-experience/india-e-mandates Invoice Indian credit cards using RBI-compliant Stripe mandates. In accordance with RBI pre-authorization requirements, this feature enables you to charge customers with Indian credit cards using Stripe mandates. After a mandate is active, Metronome will use it for eligible off-session charges. ## Setup ### 1. Collect the customer's payment method and create the mandate via SetupIntent When collecting the user's card on-session, create a mandate using a Stripe `SetupIntent`. The user completes authentication during confirmation, and Stripe creates the mandate for that payment method. ```bash theme={null} curl https://api.stripe.com/v1/setup_intents \ -u sk_test_...: \ -d customer=cus_123 \ -d payment_method=pm_123 \ -d confirm=true \ -d "payment_method_options[card][mandate_options][amount_type]"=maximum \ -d "payment_method_options[card][mandate_options][amount]"=500000 \ -d "payment_method_options[card][mandate_options][currency]"=inr \ -d "payment_method_options[card][mandate_options][interval]"=sporadic \ -d "payment_method_options[card][mandate_options][reference]"=AUTO_RECHARGE_123 \ -d "payment_method_options[card][mandate_options][start_date]"=1735689600 ``` **For threshold billing customers:** * Set `interval` to `sporadic` — recharges are triggered by a balance threshold, not a fixed cadence. * Set `amount_type` to `maximum` - support varying charge amounts. * Set `amount` to a sufficiently high value - account for variance in recharge amounts over time. **For subscriptions and recurring fees (e.g. monthly PayGo):** * Set `interval` to the corresponding recurrence (e.g. `month`). * Set `amount_type` to `fixed` if the recurring fee is known, or `maximum` if it is variable. * Set `amount` to the known recurring fee or a sufficiently high maximum. ### 2. Wait for the mandate to become active A mandate may remain in `pending` for up to 30 minutes after creation. You can check readiness in two ways: * Listen to the `mandate.updated` webhook from Stripe and wait until `status` becomes `active`. * Retrieve the mandate by ID from the `SetupIntent` and poll until it is `active`. If the mandate transitions to `inactive`, it cannot be used. The customer will need to authorize a new mandate. ### 3. Create and map the mandate custom field On the Metronome contract, create a custom field (e.g. `stripe_mandate_id`). Via the entity mapping UI, map this contract custom field to the Stripe `invoice.payment_settings` → `default_mandate` field. ### 4. Provision the customer in Metronome Create the Metronome contract. Populate the `stripe_mandate_id` custom field with the mandate ID created in step 1. All invoices sent to Stripe will attempt to attach this mandate. ### 5. Listen for the `action_required` webhook After the invoice is created with the associated mandate, the `paymentIntent` may transition to an `action_required` state. Stripe will issue a [`invoice.payment_action_required` webhook](https://docs.stripe.com/api/events/types#event_types-invoice.payment_action_required). ### 6. Confirm payment * If the customer approves the charge, the payment succeeds and the balance is released. * If the customer does not respond or the mandate becomes inactive, the payment fails and enters the normal failure workflow. A new mandate must be collected and activated before future recharge attempts can succeed. ## Limitations * Mandates must be created and managed entirely in Stripe. Metronome does not expose an API for interacting with mandates other than returning the set custom field value. * Mandates must be set up via a `SetupIntent` since all charges, including the first one, are off-session. * Metronome does not manage mandate lifecycle events. Payment failures are surfaced through the normal webhook and failure path. It is your responsibility to update the mandate in Stripe and take appropriate action before retrying. ## Relevant documentation * [Stripe guide for RBI e-mandates](https://docs.stripe.com/india-recurring-payments) # Set prepaid balance thresholds Source: https://docs.metronome.com/guides/customers-billing/optimize-customer-experience/prepaid-balance-thresholds Use *prepaid balance threshold billing* to enable a prepaid credit model for your products. This billing model requires customers to pay for usage ahead of using the product and to maintain a positive balance to continue accessing the product. Prepaid credits are modeled as [commits](/guides/pricing-packaging/apply-credits-and-commits/create-a-pre-paid-commit) in Metronome. Prepaid balance thresholds work with both fiat currencies (such as USD) and [custom pricing units](/guides/pricing-packaging/make-pricing-changes/use-currency-custompricingunits) (such as tokens or credits). This means you can configure auto recharge for customers whose balances are denominated in custom pricing units, not just fiat currency. Prepaid balance thresholds enable: * **Auto recharge:** Automatically recharge a customer's balance when it drops to the `threshold_amount` * **Manual purchase:** [Manually purchase commits](/guides/pricing-packaging/billing-model-guides/enterprise-commit/) for customers who don't want to enable auto recharge * **Payment gating:** Gate the release of the commit balance, from an auto recharge or a manual purchase, based on successful collection of payment ## Set up auto recharge with balance thresholds Configuring auto recharge of the customer's balance on a contract ensures they never lose access to the product. ### Create a contract with balance thresholds When you [create a contract](/api-reference/contracts/create-a-contract/) in Metronome, you can optionally configure a `prepaid_balance_threshold_configuration`. This config dictates: * The `threshold_amount` for the customer's contract: the balance level when a customer is recharged. * **Note:** When evaluating whether the `threshold_amount` has been reached, Metronome considers the total balance of all contract- and customer-level commits and credits. [Individual seat-scoped credits](https://docs.metronome.com/guides/pricing-packaging/subscription/provision-your-customer#individual-seat-credit) are not included in this calculation. * The `recharge_to_amount`: the balance the customer is topped up to after a recharge initiates. * A `payment_gate_config`: configure whether to gate th
[...]
